std::__atomic_base< _ITp > Struct Template Reference
Atomics

## Public Types

using | difference_type = value_type
using | value_type = _ITp

## Public Member Functions

constexpr | __atomic_base (__int_type __i) noexcept
| __atomic_base (const __atomic_base &)=delete
bool | compare_exchange_strong (__int_type &__i1, __int_type __i2, memory_order __m1, memory_order __m2) noexcept
bool | compare_exchange_strong (__int_type &__i1, __int_type __i2, memory_order __m1, memory_order __m2) volatile noexcept
bool | compare_exchange_strong (__int_type &__i1, __int_type __i2, memory_order __m=memory_order_seq_cst) noexcept
bool | compare_exchange_strong (__int_type &__i1, __int_type __i2, memory_order __m=memory_order_seq_cst) volatile noexcept
bool | compare_exchange_weak (__int_type &__i1, __int_type __i2, memory_order __m1, memory_order __m2) noexcept
bool | compare_exchange_weak (__int_type &__i1, __int_type __i2, memory_order __m1, memory_order __m2) volatile noexcept
bool | compare_exchange_weak (__int_type &__i1, __int_type __i2, memory_order __m=memory_order_seq_cst) noexcept
bool | compare_exchange_weak (__int_type &__i1, __int_type __i2, memory_order __m=memory_order_seq_cst) volatile noexcept
__int_type | exchange (__int_type __i, memory_order __m=memory_order_seq_cst) noexcept
__int_type | exchange (__int_type __i, memory_order __m=memory_order_seq_cst) volatile noexcept
__int_type | fetch_add (__int_type __i, memory_order __m=memory_order_seq_cst) noexcept
__int_type | fetch_add (__int_type __i, memory_order __m=memory_order_seq_cst) volatile noexcept
__int_type | fetch_and (__int_type __i, memory_order __m=memory_order_seq_cst) noexcept
__int_type | fetch_and (__int_type __i, memory_order __m=memory_order_seq_cst) volatile noexcept
__int_type | fetch_or (__int_type __i, memory_order __m=memory_order_seq_cst) noexcept
__int_type | fetch_or (__int_type __i, memory_order __m=memory_order_seq_cst) volatile noexcept
__int_type | fetch_sub (__int_type __i, memory_order __m=memory_order_seq_cst) noexcept
__int_type | fetch_sub (__int_type __i, memory_order __m=memory_order_seq_cst) volatile noexcept
__int_type | fetch_xor (__int_type __i, memory_order __m=memory_order_seq_cst) noexcept
__int_type | fetch_xor (__int_type __i, memory_order __m=memory_order_seq_cst) volatile noexcept
bool | is_lock_free () const noexcept
bool | is_lock_free () const volatile noexcept
__int_type | load (memory_order __m=memory_order_seq_cst) const noexcept
__int_type | load (memory_order __m=memory_order_seq_cst) const volatile noexcept
void | notify_all () noexcept
void | notify_one () noexcept
| operator __int_type () const noexcept
| operator __int_type () const volatile noexcept
__int_type | operator&= (__int_type __i) noexcept
__int_type | operator&= (__int_type __i) volatile noexcept
__int_type | operator++ () noexcept
__int_type | operator++ () volatile noexcept
__int_type | operator++ (int) noexcept
__int_type | operator++ (int) volatile noexcept
__int_type | operator+= (__int_type __i) noexcept
__int_type | operator+= (__int_type __i) volatile noexcept
__int_type | operator-- () noexcept
__int_type | operator-- () volatile noexcept
__int_type | operator-- (int) noexcept
__int_type | operator-- (int) volatile noexcept
__int_type | operator-= (__int_type __i) noexcept
__int_type | operator-= (__int_type __i) volatile noexcept
__int_type | operator= (__int_type __i) noexcept
__int_type | operator= (__int_type __i) volatile noexcept
__atomic_base & | operator= (const __atomic_base &) volatile=delete
__atomic_base & | operator= (const __atomic_base &)=delete
__int_type | operator^= (__int_type __i) noexcept
__int_type | operator^= (__int_type __i) volatile noexcept
__int_type | operator|= (__int_type __i) noexcept
__int_type | operator|= (__int_type __i) volatile noexcept
void | store (__int_type __i, memory_order __m=memory_order_seq_cst) noexcept
void | store (__int_type __i, memory_order __m=memory_order_seq_cst) volatile noexcept
void | wait (__int_type __old, memory_order __m=memory_order_seq_cst) const noexcept

## Detailed Description

### template<typename _ITp>
struct std::__atomic_base< _ITp >

Base class for atomic integrals.

Definition at line 324 of file atomic_base.h.

The documentation for this struct was generated from the following file:

- atomic_base.h